import "array-findindex-polyfill";
export interface ViewportBreakpoint {
    name: string;
    size: {
        width: number;
        height: number;
    };
}
export interface ViewportConfiguration {
    context: string;
    breakpoints: ViewportBreakpoint[];
}
export declare type ViewportCallback = (breakpoint: string) => Promise<any> | any;
declare global  {
    interface Window {
        HTMLIFrameElement: typeof HTMLIFrameElement;
    }
}
export declare function range(breakpoints: ViewportBreakpoint[], first: string, last?: string): ViewportBreakpoint[];
export declare class Viewport {
    config: ViewportConfiguration;
    context: HTMLIFrameElement;
    constructor(config: ViewportConfiguration, parent: Window);
    load(url: string, cb?: () => void): Promise<void>;
    offset(x: number, y?: number): void;
    set(width: number, height?: number): void;
    set(breakpoint: string): void;
    reset(): void;
    between(first: string, last: string, cb: ViewportCallback): void | Promise<void>;
    each(cb: ViewportCallback): void | Promise<void>;
    from(first: string, cb: ViewportCallback): void | Promise<void>;
    to(last: string, cb: ViewportCallback): void | Promise<void>;
}
